Name:           libcgroup
Version:        2.0 
Release:        1%{?dist}
Summary:        iLibrary to control and monitor control groups

License:        LGPLv2+
URL:            http://libcg.sourceforge.net/
Source0:        https://github.com/%{name}/%{name}/archive/v%{version}/%{name}-%{version}.tar.bz2
Source1:        cgconfig.service

BuildRequires:  autoconf automake libtool gcc gcc-c++ make byacc coreutils flex pam-devel systemd-units
Requires(pre):  shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
Control groups infrastructure. The library helps manipulate, control,
administrate and monitor control groups and the associated controllers.

%package        tools
Summary:        Command-line utility programs, services and daemons for libcgroup
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       systemd 

%description    tools
This package contains command-line programs, services and a daemon for
manipulating control groups using the libcgroup library.

%package        pam
Summary:        A Pluggable Authentication Module for libcgroup
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    pam
Linux-PAM module, which allows administrators to classify the user's login
processes to pre-configured control group.

%package        devel
Summary:        Development libraries to develop applications that utilize control groups
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
It provides API to create/delete and modify cgroup nodes. It will also in the
future allow creation of persistent configuration for control groups and
provide scripts to manage that configuration.


%prep
%autosetup


%build
autoreconf -vif
%configure --enable-pam-module-dir=%{_libdir}/security \
           --enable-opaque-hierarchy="name=systemd" \
           --disable-daemon

%make_build

%install
rm -rf $RPM_BUILD_ROOT
%make_install

install -d ${RPM_BUILD_ROOT}%{_sysconfdir}
install -m 644 samples/cgconfig.conf $RPM_BUILD_ROOT/%{_sysconfdir}/cgconfig.conf
install -m 644 samples/cgsnapshot_blacklist.conf $RPM_BUILD_ROOT/%{_sysconfdir}/cgsnapshot_blacklist.conf

mv -f $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.so.*.*.* $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.so
rm -f $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.{,l}a $RPM_BUILD_ROOT/%{_libdir}/security/pam_cgroup.so.*
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.{,l}a
rm -f $RPM_BUILD_ROOT/%{_libdir}/libcgroupfortesting.*
rm -f $RPM_BUILD_ROOT/%{_mandir}/man5/cgred.conf.5*
rm -f $RPM_BUILD_ROOT/%{_mandir}/man5/cgrules.conf.5*
rm -f $RPM_BUILD_ROOT/%{_mandir}/man8/cgrulesengd.8*

install -d ${RPM_BUILD_ROOT}%{_unitdir}
install -m 644 %SOURCE1 ${RPM_BUILD_ROOT}%{_unitdir}/
install -d ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig

%post tools
%systemd_post cgconfig.service

%preun tools
%systemd_preun cgconfig.service

%postun tools
%systemd_postun_with_restart cgconfig.service

%triggerun -- libcgroup < 0.38
/usr/bin/systemd-sysv-convert --save cgconfig >/dev/null 2>&1 ||:

/sbin/chkconfig --del cgconfig >/dev/null 2>&1 || :
/bin/systemctl try-restart cgconfig.service >/dev/null 2>&1 || :

%files
%{!?_licensedir:%global license %%doc}
%license COPYING
%doc README
%{_libdir}/libcgroup.so.1*
%{_libdir}/libcgset.so.0*

%files tools
%{!?_licensedir:%global license %%doc}
%license COPYING
%doc README README_systemd
%config(noreplace) %{_sysconfdir}/cgconfig.conf
%config(noreplace) %{_sysconfdir}/cgsnapshot_blacklist.conf
%{_bindir}/*
%{_sbindir}/*
%attr(0755, root, root) %{_bindir}/cgexec
%attr(0644, root, root) %{_mandir}/man1/*
%attr(0644, root, root) %{_mandir}/man5/*
%attr(0644, root, root) %{_mandir}/man8/*
%{_unitdir}/cgconfig.service

%files pam
%{!?_licensedir:%global license %%doc}
%license COPYING
%doc README
%attr(0755,root,root) %{_libdir}/security/pam_cgroup.so

%files devel
%{!?_licensedir:%global license %%doc}
%license COPYING
%doc README
%{_includedir}/libcgroup.h
%{_includedir}/libcgroup/*.h
%{_libdir}/libcgroup.so
%{_libdir}/libcgset.so
%{_libdir}/pkgconfig/libcgroup.pc

%changelog
* Tue Mar  8 2022 forrest_ly <flin@linux.alibaba.com> - 2.0-1
- Init for Anolis OS 23 
